﻿Imports System.Drawing
Imports System.IO
Imports Syncfusion.DocIO
Imports Syncfusion.DocIO.DLS

Module Module1

    Sub Main()



        Dim a As New WordDocument("etpdp.doc")
        Dim bknav As BookmarksNavigator = New BookmarksNavigator(a)
        bknav.MoveToBookmark("name")
        Dim tbp As TextBodyPart = bknav.GetBookmarkContent
        'Dim table As WTable = tbp.BodyItems(0)
        For Each item As Entity In tbp.BodyItems
            If TypeOf (item) Is WParagraph Then
                Dim existe As TextSelection = CType(item, WParagraph).Find(New System.Text.RegularExpressions.Regex("<name>"))
                If Not existe Is Nothing Then
                    CType(item, WParagraph).Replace(existe.SelectedText, "AAYADI", True, False)
                    'Replace the bookmark content
                    bknav.ReplaceBookmarkContent(tbp)

                End If
            End If
        Next
        'Iterates into each sections in Word document.
        For Each sec As WSection In a.Sections
            'Iterates into all Footers and set text in textbox.
            For Each entity As IEntity In sec.HeadersFooters.FirstPageFooter.ChildEntities
                AddTextInTextBox(entity, "Textbox in first page footer")
            Next
            For Each entity As IEntity In sec.HeadersFooters.OddFooter.ChildEntities
                AddTextInTextBox(entity, "Textbox in odd footer")
            Next
            For Each entity As IEntity In sec.HeadersFooters.EvenFooter.ChildEntities
                AddTextInTextBox(entity, "Textbox in even footer")
            Next
            'Iterates into all Headers and set text in textbox.
            For Each entity As IEntity In sec.HeadersFooters.FirstPageHeader.ChildEntities
                AddTextInTextBox(entity, "Textbox in first page header")
            Next
            For Each entity As IEntity In sec.HeadersFooters.OddHeader.ChildEntities
                AddTextInTextBox(entity, "Textbox in odd header")
            Next
            For Each entity As IEntity In sec.HeadersFooters.EvenHeader.ChildEntities
                AddTextInTextBox(entity, "Textbox in even header")
            Next
        Next



        'Replaces the text in the Word document.
        a.Replace("telSociete", "+1 919.481.1974", False, False)
        a.Replace("emailSociete", "support@syncfusion.com", False, False)
        a.Replace("sitewebSociete", "www.syncfusion.com", False, False)

        'Replaces the text with picture.
        Dim textBodyPart As TextBodyPart = New TextBodyPart(a)
        Dim paragraph As WParagraph = New WParagraph(a)
        paragraph.AppendPicture(Image.FromFile("logo.png"))
        textBodyPart.BodyItems.Add(paragraph)
        a.Replace("Logo société (grand)", textBodyPart, False, False)


        'Saves and closes the Word document.
        a.Save("Sample.doc", FormatType.Doc)
        a.Close()

        'Launch the saved document.
        System.Diagnostics.Process.Start("Sample.doc")

    End Sub
    ''' <summary>
    ''' Iterates into paragraph and change the contents of textbox.
    ''' </summary>
    ''' <param name="entity"></param>
    Private Sub AddTextInTextBox(ByVal entity As IEntity, ByVal text As String)
        If (entity.EntityType = EntityType.Paragraph) Then
            'Iterates into each items in paragraph.
            For Each para As IEntity In CType(entity, WParagraph).ChildEntities
                If (para.EntityType = EntityType.TextBox) Then
                    Dim textbox As WTextBox = CType(para, WTextBox)
                    'Append text in the textbox.
                    textbox.TextBoxBody.Paragraphs(0).AppendText(text)
                    'Fills the color in textbox
                    textbox.TextBoxFormat.FillColor = Color.Red
                    'Resize the textbox size to fit based on the contents.
                    textbox.TextBoxFormat.AutoFit = True
                End If
            Next
        End If

    End Sub

End Module
